use std::path::PathBuf;

use super::{Relocatable, Section};
use crate::error::Error;

pub trait Output<R>
where
    R: Relocatable,
{
    fn process_section(&mut self, section: Section) -> Result<(), Error>;

    fn finalize(self, objects: &[R]) -> Result<PathBuf, Error>;
}
